---
title: 'Privacy and the :visited selector'
slug: 'Web/CSS/Privacy_and_the_:visited_selector'
tags:
  - CSS
  - Guide
  - Pseudo-class
  - Reference
  - Security
  - Selectors
---
<div>{{cssref}}</div>

<p>Before about 2010, the <a href="/en-US/docs/Web/CSS">CSS</a> {{ cssxref(":visited") }} selector allowed websites to uncover a user's browsing history and figure out what sites the user had visited. This was done through {{domxref("window.getComputedStyle")}} and other techniques. This process was quick to execute, and made it possible not only to determine where the user had been on the web, but could also be used to guess a lot of information about the user's identity.</p>

<p>To mitigate this problem, browsers have limited the amount of information that can be obtained from visited links.</p>

<h2 id="Little_white_lies">Little white lies</h2>

<p>To preserve users' privacy, Firefox and other browsers will lie to web applications under certain circumstances:</p>

<ul>
 <li>The <code>window.getComputedStyle</code> method, and similar functions such as {{ domxref("element.querySelector") }}, will always return values indicating that a user has never visited any of the links on a page.</li>
 <li>If you use a sibling selector such as <code>:visited + span</code>, the adjacent element (<code>span</code> in this example) will be styled as if the link were unvisited.</li>
 <li>In rare scenarios, if you're using nested link elements and the element being matched is different from the link whose presence in history is being tested, the element will be rendered as if the link were unvisited, as well.</li>
</ul>

<h2 id="Limits_to_visited_link_styles">Limits to visited link styles</h2>

<p>You can style visited links, but there are limits to which styles you can use. Only the following styles can be applied to visited links:</p>

<ul>
 <li>{{ cssxref("color") }}</li>
 <li>{{ cssxref("background-color") }}</li>
 <li>{{ cssxref("border-color") }} (and its sub-properties)</li>
 <li>{{ cssxref("column-rule-color") }}</li>
 <li>{{ cssxref("outline-color") }}</li>
 <li>The color parts of the {{SVGAttr("fill")}} and {{SVGAttr("stroke")}} attributes</li>
</ul>

<p>In addition, even for the above styles, you won't be able to change the transparency between unvisited and visited links, as you otherwise would be able to using <code><a href="/en-US/docs/Web/CSS/color_value#rgba()">rgba()</a></code>, <code><a href="/en-US/docs/Web/CSS/color_value#hsla()">hsla()</a></code>, or the <code><a href="/en-US/docs/Web/CSS/color_value#transparent">transparent</a></code> keyword.</p>

<p>Here is an example of how to use styles with the aforementioned restrictions:</p>

<pre class="brush: css">:link {
  outline: 1px dotted blue;
  background-color: white;
  /* The default value of background-color is `transparent`. You need to
     specify a different value, otherwise changes on :visited won't apply. */
}

:visited {
  outline-color: orange;    /* Visited links have an orange outline */
  background-color: green;  /* Visited links have a green background */
  color: yellow;            /* Visited links have yellow colored text */
}
</pre>

<h2 id="Impact_on_web_developers">Impact on web developers</h2>

<p>Overall, these restrictions shouldn't affect web developers too significantly. They may, however, require the following changes to existing sites:</p>

<ul>
 <li>Using background images to style links based on whether they've been visited will no longer work, since only colors can be used to style visited links.</li>
 <li>Colors that are otherwise transparent will fail to appear if styled in a <code>:visited</code> selector.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li><a class="external" href="http://hacks.mozilla.org/2010/03/privacy-related-changes-coming-to-css-vistited/">privacy-related changes coming to CSS :visited</a> on Mozilla Hacks</li>
 <li><a class="external" href="http://blog.mozilla.com/security/2010/03/31/plugging-the-css-history-leak/">Plugging the CSS History Leak</a> on the Mozilla Security Blog</li>
 <li><a class="external" href="http://dbaron.org/mozilla/visited-privacy">Preventing attacks on a user's history through CSS :visited selectors</a></li>
</ul>
